Panda3D

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
ov_set< Key, Compare, Vector > Class Template Reference

A specialization of ordered_vector that emulates a standard STL set: one copy of each element is allowed. More...

`#include "ordered_vector.h"`

Inheritance diagram for ov_set< Key, Compare, Vector >:

## Public Types
typedef ordered_vector< Key, Compare, Vector >::iterator_0 | iterator_0
typedef ordered_vector< Key, Compare, Vector >::value_type_0 | value_type_0
Public Types inherited from ordered_vector< Key, Compare, Vector >
typedef const_iterator_0 | const_iterator
typedef Vector::const_iterator | const_iterator_0
typedef const_reference_0 | const_reference
typedef const Key & | const_reference_0
typedef const_reverse_iterator_0 | const_reverse_iterator
typedef Vector::const_reverse_iterator | const_reverse_iterator_0
typedef difference_type_0 | difference_type
typedef Vector::difference_type | difference_type_0
typedef iterator_0 | iterator
typedef Vector::iterator | iterator_0
typedef key_compare_0 | key_compare
typedef Compare | key_compare_0
typedef key_type_0 | key_type
typedef Key | key_type_0
typedef reference_0 | reference
typedef Key & | reference_0
typedef reverse_iterator_0 | reverse_iterator
typedef Vector::reverse_iterator | reverse_iterator_0
typedef size_type_0 | size_type
typedef Vector::size_type | size_type_0
typedef value_compare_0 | value_compare
typedef Compare | value_compare_0
typedef value_type_0 | value_type
typedef Key | value_type_0

## Public Member Functions
| ov_set (const Compare &compare, TypeHandle type_handle=ov_set_type_handle)
| ov_set (TypeHandle type_handle=ov_set_type_handle)
std::pair< iterator_0, bool > | insert (const value_type_0 &key0)
iterator_0 | insert (iterator_0 position, const value_type_0 &key0)
void | sort ()
| Maps to sort_unique().
bool | verify_list () const
| Maps to verify_list_unique().
Public Member Functions inherited from ordered_vector< Key, Compare, Vector >
| ordered_vector (const Compare &compare, TypeHandle type_handle=ov_set_type_handle)
| ordered_vector (TypeHandle type_handle=ov_set_type_handle)
reference | back ()
| Returns a reference to the first element.
const_reference | back () const
| Returns a const reference to the last element.
iterator_0 | begin ()
| Returns the iterator that marks the first element in the ordered vector.
const_iterator_0 | begin () const
| Returns the iterator that marks the first element in the ordered vector.
const_iterator_0 | cbegin () const
| Returns the iterator that marks the first element in the ordered vector.
const_iterator_0 | cend () const
| Returns the iterator that marks the end of the ordered vector.
void | clear ()
| Removes all elements from the ordered vector.
size_type_0 | count (const key_type_0 &key) const
| Returns the number of elements that sort equivalent to the key that are in the vector.
const_reverse_iterator_0 | crbegin () const
| Returns the iterator that marks the first element in the ordered vector, when viewed in reverse order.
const_reverse_iterator_0 | crend () const
| Returns the iterator that marks the end of the ordered vector, when viewed in reverse order.
bool | empty () const
| Returns true if the ordered vector is empty, false otherwise.
iterator_0 | end ()
| Returns the iterator that marks the end of the ordered vector.
const_iterator_0 | end () const
| Returns the iterator that marks the end of the ordered vector.
std::pair< iterator_0, iterator_0 > | equal_range (const key_type_0 &key)
std::pair< const_iterator_0, const_iterator_0 > | equal_range (const key_type_0 &key) const
size_type_0 | erase (const key_type_0 &key)
void | erase (iterator_0 first, iterator_0 last)
iterator_0 | erase (iterator_0 position)
iterator_0 | find (const key_type_0 &key)
const_iterator_0 | find (const key_type_0 &key) const
iterator_0 | find_particular (const key_type_0 &key)
const_iterator_0 | find_particular (const key_type_0 &key) const
reference | front ()
| Returns a reference to the first element.
const_reference | front () const
| Returns a const reference to the first element.
iterator_0 | insert_nonunique (const value_type_0 &key)
iterator_0 | insert_nonunique (iterator_0 position, const value_type_0 &key)
std::pair< iterator_0, bool > | insert_unique (const value_type_0 &key)
iterator_0 | insert_unique (iterator_0 position, const value_type_0 &key)
iterator_0 | insert_unverified (iterator_0 position, const value_type_0 &key)
| Inserts the indicated key into the ordered vector at the indicated place.
iterator_0 | lower_bound (const key_type_0 &key)
const_iterator_0 | lower_bound (const key_type_0 &key) const
size_type_0 | max_size () const
| Returns the maximum number of elements that can possibly be stored in an ordered vector.
bool | operator!= (const ordered_vector< Key, Compare, Vector > &other) const
| Returns true if the two ordered vectors are not memberwise equivalent, false if they are.
bool | operator< (const ordered_vector< Key, Compare, Vector > &other) const
| Returns true if this ordered vector sorts lexicographically before the other one, false otherwise.
bool | operator<= (const ordered_vector< Key, Compare, Vector > &other) const
| Returns true if this ordered vector sorts lexicographically before the other one or is equivalent, false otherwise.
bool | operator== (const ordered_vector< Key, Compare, Vector > &other) const
| Returns true if the two ordered vectors are memberwise equivalent, false otherwise.
bool | operator> (const ordered_vector< Key, Compare, Vector > &other) const
| Returns true if this ordered vector sorts lexicographically after the other one, false otherwise.
bool | operator>= (const ordered_vector< Key, Compare, Vector > &other) const
| Returns true if this ordered vector sorts lexicographically after the other one or is equivalent, false otherwise.
reference | operator[] (size_type_0 n)
const_reference | operator[] (size_type_0 n) const
void | pop_back ()
| Removes the last element at the end of the vector.
void | push_back (const value_type_0 &key)
| Adds the new element to the end of the vector without regard for proper sorting.
void | push_back (value_type_0 &&key)
| Adds the new element to the end of the vector without regard for proper sorting.
reverse_iterator_0 | rbegin ()
| Returns the iterator that marks the first element in the ordered vector, when viewed in reverse order.
const_reverse_iterator_0 | rbegin () const
| Returns the iterator that marks the first element in the ordered vector, when viewed in reverse order.
reverse_iterator_0 | rend ()
| Returns the iterator that marks the end of the ordered vector, when viewed in reverse order.
const_reverse_iterator_0 | rend () const
| Returns the iterator that marks the end of the ordered vector, when viewed in reverse order.
void | reserve (size_type_0 n)
| Informs the vector of a planned change in size; ensures that the capacity of the vector is greater than or equal to n.
void | resize (size_type_0 n)
void | resize (size_type_0 n, const value_type_0 &value)
size_type_0 | size () const
| Returns the number of elements in the ordered vector.
void | sort_nonunique ()
| Ensures that the vector is properly sorted after a potentially damaging operation.
void | sort_unique ()
| Ensures that the vector is properly sorted after a potentially damaging operation.
void | swap (ordered_vector< Key, Compare, Vector > &other)
| Exchanges the contents of this vector and the other vector, in constant time (e.g., with a pointer swap).
iterator_0 | upper_bound (const key_type_0 &key)
const_iterator_0 | upper_bound (const key_type_0 &key) const
bool | verify_list_nonunique () const
bool | verify_list_unique () const

## Detailed Description

template<class Key, class Compare = std::less<Key>, class Vector = pvector<Key>>
class ov_set< Key, Compare, Vector >

A specialization of ordered_vector that emulates a standard STL set: one copy of each element is allowed.

Definition at line 269 of file ordered_vector.h.

## Member Typedef Documentation

## ◆ iterator_0

template<class Key, class Compare = std::less<Key>, class Vector = pvector<Key>>

typedef ordered_vector<Key,Compare,Vector>::iterator_0 ov_set< Key, Compare, Vector >::iterator_0

Definition at line 271 of file ordered_vector.h.

## ◆ value_type_0

template<class Key, class Compare = std::less<Key>, class Vector = pvector<Key>>

typedef ordered_vector<Key,Compare,Vector>::value_type_0 ov_set< Key, Compare, Vector >::value_type_0

Definition at line 272 of file ordered_vector.h.

## Constructor & Destructor Documentation

## ◆ ov_set() [1/2]

template<class Key, class Compare, class Vector>

ov_set< Key, Compare, Vector >::ov_set | ( | TypeHandle | type_handle = ov_set_type_handle | ) |
| inline

Definition at line 691 of file ordered_vector.I.

## ◆ ov_set() [2/2]

template<class Key, class Compare, class Vector>

ov_set< Key, Compare, Vector >::ov_set | ( | const Compare & | compare,
|  | TypeHandle | type_handle = ov_set_type_handle )
| inline

Definition at line 701 of file ordered_vector.I.

## Member Function Documentation

## ◆ sort()

template<class Key, class Compare, class Vector>

void ov_set< Key, Compare, Vector >::sort | ( |  | ) |
| inline

Maps to sort_unique().

Definition at line 730 of file ordered_vector.I.

References ordered_vector< Key, Compare, Vector >::sort_unique().

Referenced by ClipPlaneAttrib::filter_to_max(), RenderEffects::make(), RenderEffects::make(), RenderEffects::make(), InputDeviceSet::remove_devices_from(), LightAttrib::replace_off_light(), LightAttrib::replace_on_light(), and VirtualFile::scan_directory().

## ◆ verify_list()

template<class Key, class Compare, class Vector>

bool ov_set< Key, Compare, Vector >::verify_list | ( |  | ) | const
| inline

Maps to verify_list_unique().

Definition at line 739 of file ordered_vector.I.

The documentation for this class was generated from the following files:

- panda/src/express/ordered_vector.h
- panda/src/express/ordered_vector.I